var AutoFormer = {

// my variables ------------------------------------------------------------
m_LastInput: null,
m_Inputs: [],
m_LoadDelayCount: 0,
m_Profiles: [],
m_CurrentProfile: "",
m_PrefixSep: "AF1@",

// dummy debug dump ------------------------------------------------------------------
ddd: function(msg) 
{
/*
  var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
                       .getService(Components.interfaces.nsIConsoleService);
  consoleService.logStringMessage("===" + msg + "===");
*/
},

//------------------------------------------------------------------------------
GetRecordNamePrefix: function() 
{
 var prefix = "";
 if(this.m_CurrentProfile != "")
  prefix += this.m_CurrentProfile + "#";
 prefix += this.m_PrefixSep;
 return prefix;
},


//------------------------------------------------------------------------------
ltrim: function(str) 
{
 while(str[0] == " ")
  str = str.substr(1); 
 return str;
},

//------------------------------------------------------------------------------
GetPropStr: function(id)
{
 var strings = document.getElementById("autoformer_sb");
 return strings.getString (id);
},
         
//------------------------------------------------------------------------------
SaveRecord: function(doc, name, value) 
{
 doc.defaultView.localStorage.setItem(escape(name), escape(value));
},
         
//------------------------------------------------------------------------------
ClearCookie: function(doc, name) 
{
 var cookie = name + "=;expires=Thu, 01-Jan-70 00:00:01 GMT;path=/;";
 doc.cookie = cookie;
},

//------------------------------------------------------------------------------
IsInputSaveble: function(input) 
{
 if(input.offsetWidth < 1) // We don`t save hiddent inputs
  return false;

 var result = true;
 var type = input.getAttribute("type");
 if (type != null)
 {
  type = type.toLowerCase();
  if (type == "button" || type == "hidden" || type == "image" || type == "submit")
   result = false;
 }
 return result;
},

//------------------------------------------------------------------------------
SaveElement: function(doc, element)
{
 var value="";
 var to_save = true;
 var nodeName = element.nodeName.toString().toLowerCase();
 if(nodeName == "textarea")
  value = element.value;
 if(nodeName == "input")
 {
  var type = element.getAttribute("type");
  if(type != null)
   type = type.toLowerCase();
  if(type == "checkbox")
   value = element.checked;
  else
  if(type == "radio")
  {
   if(element.checked)
    value = element.value;
   else
    to_save = false;
  }
  else
   value = element.value;
 }
 if(nodeName == "select")
 {
  for(var i=0; i<element.options.length; i++)
  {
   if(element.options.item(i).selected)
    value += element.options.item(i).value + "@";
  }
 }

 if(to_save)
  this.SaveRecord(doc, 
                  this.GetRecordNamePrefix() + element.form.name + "@" + element.name, 
                  value);
},

//------------------------------------------------------------------------------

SaveForms: function(win) 
{
 // Process self frame //
 var doc = win.document;

 // save forms
 for(var f=0; f<doc.forms.length; f++)
 {
  var form = doc.forms.item(f);
  for(var e=0; e<form.elements.length; e++)
  {
   var element = form.elements.item(e);
   var can_save = false;
   var nodeName = element.nodeName.toString().toLowerCase();
   if(nodeName == "textarea" || 
      nodeName == "select" || 
      (nodeName == "input" && this.IsInputSaveble(element)))
    can_save = true;
   if(can_save)
    this.SaveElement(doc, element);
  }
 }

 // Process subframes //
 for (var i=0; i<win.frames.length; i++)
 {
  this.SaveForms(win.frames[i]);
 }
},

////////////////////////////////////////////////////////////////////////////////

OnContextPopupShowing: function()
{
 var isHidden = true;

 if (gContextMenu != null)
 { 
  var targetName = gContextMenu.target.nodeName.toString().toLowerCase();
  var isSelect = (targetName == "select");
  if(gContextMenu.onTextInput || isSelect)
  {
   isHidden = false;
   this.m_LastInput = gContextMenu.target;
  }
 }
                                    
 document.getElementById("autoformer_context").hidden = isHidden;
},

//------------------------------------------------------------------------------
OnPopupShowing: function (prefix)
{
 var disable = window._content.document.domain.length < 3;
 var dataAbsent = !(this.HasAutoFormerData(window._content));

 document.getElementById("autoformer_context_mi_so").setAttribute("disabled", disable);
 document.getElementById(prefix+"mi_sa").setAttribute("disabled", disable);
 document.getElementById(prefix+"mi_l" ).setAttribute("disabled", disable || dataAbsent);
 document.getElementById(prefix+"mi_ca").setAttribute("disabled", disable || dataAbsent);
 //--
 document.getElementById(prefix+"mi_sp").setAttribute("disabled", disable);
 //--
 this.m_Profiles = [];
 if(!disable) 
  this.UpdateProfiles4Win(window._content);
 document.getElementById(prefix+"m_lp").setAttribute("disabled", this.m_Profiles.length == 0);
 document.getElementById(prefix+"m_cp").setAttribute("disabled", this.m_Profiles.length == 0);

 if(this.m_Profiles.length)
 {
  // Load ------------------------------
  var mt_lp = document.getElementById(prefix+"mi_lp_");
 
  // remove previous profiles
  while (mt_lp.nextSibling != null)
   mt_lp.parentNode.removeChild (mt_lp.nextSibling);

  // append new profiles
  for(var i=0; i<this.m_Profiles.length; i++)
  {
    mt_lp.setAttribute("label", this.m_Profiles[i]); // fix FF3 bug 
    var mi_new = mt_lp.cloneNode(true);
    mi_new.setAttribute("hidden", false);
    mi_new.setAttribute("label", this.m_Profiles[i]);
    mi_new.setAttribute("id", prefix+"mi_lp_"+i);
    mt_lp.parentNode.appendChild (mi_new);
  }

  // Clear -----------------------------
  var mt_cp = document.getElementById(prefix+"mi_cp_");
 
  // remove previous profiles
  while (mt_cp.nextSibling != null)
   mt_cp.parentNode.removeChild (mt_cp.nextSibling);

  // append new profiles
  for(var i=0; i<this.m_Profiles.length; i++)
  {
    mt_cp.setAttribute("label", this.m_Profiles[i]); // fix FF3 bug 
    var mi_new = mt_cp.cloneNode(true);
    mi_new.setAttribute("hidden", false);
    mi_new.setAttribute("label", this.m_Profiles[i]);
    mi_new.setAttribute("id", prefix+"mi_cp_"+i);
    mt_cp.parentNode.appendChild (mi_new);
  }
 }
},

////////////////////////////////////////////////////////////////////////////////

OnSaveOne: function(event) 
{
 if (this.m_LastInput != null)
 {
  this.m_CurrentProfile = "";
  this.SaveElement(this.m_LastInput.ownerDocument, this.m_LastInput);
 }
},

//------------------------------------------------------------------------------
OnSaveAll: function(event)
{
 this.m_CurrentProfile = "";
 this.SaveForms(window._content);
},

//------------------------------------------------------------------------------
OnLoadAll: function() 
{
 this.m_CurrentProfile = "";
 this.FillForms4Win(window._content);
},

//------------------------------------------------------------------------------
OnClearAll: function(event) 
{
 var ls = window._content.localStorage;
 var lsLen = ls.length;
 var recordPrefix = this.m_PrefixSep;

 for(var i=lsLen-1; i>=0; i--)
 {
  var key = ls.key(i);
  if(key.indexOf(recordPrefix) != -1) // AutoFormer record
   ls.removeItem(key);
 }
},

//==============================================================================
OnSaveProfile: function(event) 
{
 var profileName = this.GetPropStr("af.new.profile");

 // prompt service
 var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
 var profileObj = new Object();
 var checkObj = new Object();
 profileObj.value=profileName;
 if(promptService.prompt(window,
                         this.GetPropStr("af.prompt.save.caption"), 
                         this.GetPropStr("af.prompt.save.question"), 
                         profileObj, null, checkObj) && 
    profileObj.value.length > 0) 
 {
   profileName=profileObj.value;
   this.m_CurrentProfile = profileName;
   this.SaveForms(window._content);
 }
},

//------------------------------------------------------------------------------
OnLoadProfile: function(event) 
{
 this.m_CurrentProfile = event.target.getAttribute("label");
 this.FillForms4Win(window._content);
},

//------------------------------------------------------------------------------
OnClearProfile: function(event) 
{
 var profileName = event.target.getAttribute("label");
 var ls = window._content.localStorage;
 var lsLen = ls.length;
 var recordPrefix = escape(profileName+"#"+this.m_PrefixSep);

 //this.ddd("OnClearProfile: recordPrefix="+recordPrefix); //###

 for(var i=lsLen-1; i>=0; i--)
 {
  var keyRaw = ls.key(i);
  if(keyRaw.indexOf(recordPrefix) == 0) // AutoFormer profile record
   ls.removeItem(keyRaw);
 }
},

//------------------------------------------------------------------------------
UpdateProfiles4Win: function(win)
{
 var ls = win.localStorage;
 var lsLen = ls.length;       
 var profilePrefix = "#"+this.m_PrefixSep;

 for(var i=0; i<lsLen; i++)
 {
  var key = unescape(ls.key(i));
  if(key.indexOf(profilePrefix) != -1) // key has AutoFormer profile
  {
   var keyInfo = key.split("#");
   var profileName = keyInfo[0];

   var in_list = false;
   for(p=0; p<this.m_Profiles.length; p++)
   {
    if(this.m_Profiles[p] == profileName)
    {
     in_list = true;
     break;
    }
   }

   if(!in_list)
   {
    this.m_Profiles.push(profileName);
   }
  }
 }

},

//------------------------------------------------------------------------------
CheckAndConvertCookies: function(doc)
{
 //cookie sample: zzz-profile#AF1@f1@comment=sample%20text
 //               zzz-profile#AF1@f1@nick= 
 
 if(doc.cookie.indexOf(this.m_PrefixSep) == -1)
  return; // there are no AutoFormer cookies

 var cookieList = doc.cookie.split(";");
 for(var i=0; i<cookieList.length; i++)
 {
  var cookie = this.ltrim(cookieList[i]);
  if(cookie.indexOf(this.m_PrefixSep) != -1) // It is AutoFormer cookie!
  {
   var cookieData = cookie.split("=");
   var cookieNameRaw = cookieData[0];
   var cookieName = unescape(cookieNameRaw);
   var cookieValue = unescape(cookieData[1]);

   this.SaveRecord(doc, cookieName, cookieValue);
   this.ClearCookie(doc, cookieNameRaw); 
  }
 }
},

//------------------------------------------------------------------------------
ParseData4Doc: function(doc)
{
 this.CheckAndConvertCookies(doc);

 var recordPrefix = escape(this.GetRecordNamePrefix());
 var ls = doc.defaultView.localStorage;
 var lsLen = ls.length;

 //this.ddd("ParseData4Doc: recordPrefix="+recordPrefix); // ###

 for(var i=0; i<lsLen; i++)
 {
  var key = ls.key(i);

  //this.ddd("ParseData4Doc: key="+key); // ###

  if(key.indexOf(recordPrefix) == 0) // wanted profile record
  {
   var fieldDetailes = key.split("@");
   var formName = unescape(fieldDetailes[1]);
   var fieldName = unescape(fieldDetailes[2]);
   var fieldValue = unescape(ls.getItem(key));
   this.m_Inputs.push(new Array(formName, fieldName, fieldValue));
   //this.ddd("ParseData4Doc: formName="+formName+"; fieldName="+fieldName+"; fieldValue="+fieldValue+";"); // ###
  }
 }
},

//------------------------------------------------------------------------------
HasAutoFormerData: function(win)
{
 var result = false;

 var recordPrefix = this.m_PrefixSep;
 var ls = win.localStorage;
 var lsLen = ls.length;

 for(var i=0; i<lsLen; i++)
 {
  var key = ls.key(i);
  if(key.indexOf(recordPrefix) != -1) // has AutoFormer record
  {
    result = true;
    break;
  }
 }

 return result;
},

//------------------------------------------------------------------------------
FillFields4Doc: function(doc)
{
 if (this.m_Inputs.length)
 {
  if(doc.forms.length)
   this.FillFields4DocNow(doc);
  else
  {
   if(this.m_LoadDelayCount < 10)
   {
    this.m_LoadDelayCount++;
    doc.defaultView.setTimeout(function(){ AutoFormer.FillFields4Doc(doc) }, 1000);
   }
  }
 }
},

//------------------------------------------------------------------------------
FillFields4DocNow: function(doc)
{
 for(var f=0; f<doc.forms.length; f++)
 {
  var form = doc.forms.item(f);
  for(var e=0; e<form.elements.length; e++)
  {
   var element = form.elements.item(e);
   //this.ddd ("FillFields4DocNow-1: check element:"+element.name+";"); //###
   for(var m=0; m<this.m_Inputs.length; m++)
   {
    if(element.name == this.m_Inputs[m][1] && form.name == this.m_Inputs[m][0])
    {
     //this.ddd ("FillFields4DocNow-2: element found!"); //###

     var nodeName = element.nodeName.toString().toLowerCase();
     if(nodeName == "textarea")
      element.value = this.m_Inputs[m][2];
     else
     if(nodeName == "input")
     {
      var type = element.getAttribute("type");
      if(type != null)
       type = type.toLowerCase();
      if(type == "checkbox")
       element.checked = (this.m_Inputs[m][2] == "true");
      else
      if(type == "radio")
       element.checked = element.value == this.m_Inputs[m][2];
      else
      {
       element.value = this.m_Inputs[m][2];
       //this.ddd ("FillFields4DocNow-3: set element value:"+this.m_Inputs[m][2]+";"); //###
      }
     }
     else
     if(nodeName == "select")
     {
      for(var i=0; i<element.options.length; i++)
       element.options.item(i).selected = this.m_Inputs[m][2].indexOf(element.options.item(i).value + "@") != -1;
     }

     break;
    }
   }
  }
 }
},

//------------------------------------------------------------------------------
FillForms4Doc: function(doc) 
{
 if(doc.domain.length > 3)
 {
  this.m_Inputs = [];
  this.m_LoadDelayCount = 0;
  this.ParseData4Doc(doc);
  this.FillFields4Doc(doc);
 }
},

//------------------------------------------------------------------------------
FillForms4Win: function(win) 
{
 // Process self frame //
 var doc = win.document;

 this.FillForms4Doc(doc);

 // Process subframes //
 for (var i=0; i<win.frames.length; i++)
 {
  this.FillForms4Win(win.frames[i]);
 }
},

////////////////////////////////////////////////////////////////////////////////
OnPageLoad: function(event) 
{
 // event.originalTarget             - document
 // event.originalTarget.defaultView - window

 try
 {
  if(event.originalTarget.domain != null)
  {
   // Context menu
   var menu = document.getElementById("contentAreaContextMenu");
   menu.addEventListener("popupshowing", function(){ AutoFormer.OnContextPopupShowing(); }, false);

   this.m_CurrentProfile = "";
   AutoFormer.FillForms4Doc(event.originalTarget);
  }
 }catch(e){}
},

////////////////////////////////////////////////////////////////////////////////
OnDebugInfo: function() 
{
 try
 {
  // Storage Info
  var ls = window._content.localStorage;
  var str = "localStorage size: "+ls.length;
  for(var i=1; i<=ls.length; i++)
  {
   var key = ls.key(i-1);
   var value = ls.getItem(key);
   str += "\n"+i+": "+key+"="+value;
  }

  // Cookies Info
  str += "\n\nCookies:\n" + window._content.document.cookie;
 
  // Inputs Info
  str += "\n\nInputs:\n"
  var inputs = window._content.document.getElementsByTagName("input");
  for (var i=0; i<inputs.length; i++)
  {
   var input = inputs[i];
   var type = input.getAttribute("type");
   if(type != null)
    type = type.toLowerCase();
   if (type == null || type == "" || type == "text" || type == "password" || type == "search")
    str += input.name + "=" + input.value + "; input.offsetWidth="+ input.offsetWidth +";\n";
  }
 
  alert(str); 

 }catch(e){ alert(e); }
},

};

/*
function z_load(event)
{
//  doc.title = "load";
  var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
                       .getService(Components.interfaces.nsIConsoleService);
  consoleService.logStringMessage("==="+event.originalTarget.title);
  //consoleService.logStringMessage("==="+window._content.document.title);
}
*/


//------------------------------------------------------------------------------
window.addEventListener("DOMContentLoaded", AutoFormer.OnPageLoad, true); 

//window.addEventListener("DOMContentLoaded", AutoFormer.OnPageLoad, true); // failed on login.alibaba.com
//window.addEventListener("load", z_load, false); // lermont+ alibaba-
//window.addEventListener("load", function(event) { z_load(event); } , false); lermont+ alibaba-
